.intel_syntax noprefix

.text

.global minmax

# void minmax(int *a, int n, int *pmin, int *pmax)
#  -           rdi     esi     rdx        rcx

minmax:
    enter 0, 0

    mov r8d, [rdi]   # r8d - max = a[0]
    mov r9d, [rdi]   # r9d - min = a[0]
    mov r10, rcx
    mov ecx, 1 	# ecx - i

for_loop:
	cmp ecx, esi
	je for_loop_end	
	
	mov r11d, [rdi + 4*rcx] # r11d = a[i]

    cmp r11d, r8d
    jle nije_vece
		mov r8d, r11d
		
nije_vece:
	cmp r11d, r9d
    jge nije_manje
    	mov r9d, r11d

nije_manje:
	inc ecx		
	jmp for_loop	

for_loop_end:
    mov [rdx], r9d
    mov [r10], r8d
    
    leave
    ret
